
import template from './entity-details.tmpl.html';

export default function entityDetails( $log, $state, $stateParams, $ngRedux)
{
    return {
        restrict: 'E',
        scope: {
        },
        require: '^propertiesContext',
        template: template,
        link: function( $scope, $element, $attributes, propertiesContext) {
            $log.debug( 'entityDetails link');
            
            var selected            =   -1;
            var original            =   null; //              =   angular.copy( $scope.intent);
            
            
            $scope.onUpdate         =   function( entity) {
                $log.debug( 'entityDetails onUpdate entity', entity);
                $scope.$applyAsync( function () {
                    $scope.current_entity     =   angular.copy( entity);
                });
            }
            
            $scope.submitEntity = function() {
                propertiesContext.updateConvoEntity( $scope.current_entity, parseInt( $stateParams.index));
                $state.go('^.intent-model');
            }

            $scope.isEntityChanged = function() {
                return !angular.equals( original, $scope.current_entity);
            }
            

            propsToScope( $ngRedux.getState());
            
            var unsubscribe = $ngRedux.subscribe(() => {
                $log.debug( 'entityDetails subscribe');
                propsToScope( $ngRedux.getState());
            });
            
            function propsToScope( state)
            {
                $log.debug( 'entityDetails propsToScope', state.entities);
                selected               =   parseInt( $stateParams.index);
                $scope.current_entity  =   state.entities.data[selected];
                
                if ( !original) {
                    original     =   angular.copy( $scope.current_entity);
                }
            }
            
            $scope.$on( "$destroy", function () {
                $log.debug( 'entityDetails destroy');
                unsubscribe();
            });
        }
    }
}