
import template from './intents-list.tmpl.html';

import { removeIntent } from "./store";

export default function intentList( $log, $window, $state, $ngRedux)
{
    return {
        restrict: 'E',
        scope: {},
        template: template,
        link: function( $scope, $element, $attributes) {
            $log.debug( 'intentList link');

            propsToScope( $ngRedux.getState());

            var unsubscribe = $ngRedux.subscribe(() => {
                propsToScope( $ngRedux.getState());
            });

            function propsToScope( state)
            {
                $scope.intents   =   state.intents.data;
                $scope.selected  =   state.intents.selected;
            }

            $scope.$on( "$destroy", unsubscribe )

            $scope.deleteIntent = function($event, index) {
                $event.preventDefault();
                $event.stopPropagation();

                var intentName = $scope.intents[index].name;
                if ( $window.confirm( "Are you sure you want to delete " + intentName + "?")) {
                    $ngRedux.dispatch( removeIntent( index));
                }
            }

            $scope.navigateToIntent = function(index) {
                $state.go('convoworks-editor-service.intent-details', { index });
            }
        }
    }
};
