
export const setIntents = ( intents) => {
  return { type: 'SET_INTENTS', payload : intents }
}

export const removeIntent = ( index) => {
  return { type: 'REMOVE_INTENT', payload : index }
}

export const addIntent = ( intent) => {
  return { type: 'ADD_INTENT', payload : intent}
}

export const updateIntent = ( intent, index) => {
  return { type: 'UPDATE_INTENT', payload : {
    intent : intent,
    index : index
}}
}

export const selectIntent = ( index) => {
    return { type: 'SELECT_INTENT', payload : index };
}



const defaultState  =   {
    data : [],
    selected : -1,
    ready : false,
};


export default (state = defaultState, {type, payload}) => {
    switch(type) {
        
        case 'CLEAR_SERVICE':
            return Object.assign( {}, defaultState);
            
        case 'SET_INTENTS': 
            return Object.assign( {}, state, { data: payload, ready : true});
            
        case 'ADD_INTENT': 
            return Object.assign( {}, state, { data: [...state.data, payload]});
            
        case 'REMOVE_INTENT': 
            state.data.splice( payload, 1);
            return Object.assign( {}, state, { data: state.data});
            
        case 'UPDATE_INTENT': 
            Object.assign( state.data[payload.index], payload.intent);
            return Object.assign( {}, state);
            
        case 'SELECT_INTENT': 
            return Object.assign( {}, state, { selected : payload});
            
        default: 
            return state;
    }
}
