import appModule from './app.module';

import 'angular-local-storage';

import './style.css';
import './forms.css';
import './convoworks-editor.css';

import app_route from './app.ui-route';

appModule.config( app_route);

//import loggingMiddleware from './loggingMiddleware';

import reducer from './reducer';
import thunk from "redux-thunk";
//import logger from "redux-logger";
import promiseMiddleware from "redux-promise-middleware";

import { createLogger } from 'redux-logger';

console.log('reducer', reducer);

const logger = createLogger({
  level: 'info',
  collapsed: false
});

appModule.run( function ( $document, $rootScope) {
    $document.bind('keydown', function (e) {
        if (e.keyCode === 27) {
            $rootScope.$apply( function () {
                $rootScope.$broadcast('EscKeyPressed');
            })
        }
    });
});

export default appModule
    .config( function ( localStorageServiceProvider) {
      localStorageServiceProvider
        .setPrefix( 'convoAdmin')
//      .setStorageType( 'sessionStorage')
        .setNotify( true, true)
    })
    .config( ($ngReduxProvider) => {
//    $ngReduxProvider.createStoreWith( reducer, ['promiseMiddleware', thunk, logger]);
    $ngReduxProvider.createStoreWith( reducer, [ promiseMiddleware, thunk, logger]);
  })
    .name;
